#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include <pthread.h>

#define ERR(msg)  { fprintf(stderr,"%s(%d): %s\n", \
                            __FILE__,__LINE__,msg) ; \
                    exit(1) ; }

#define ERR2(msg,arg)  { \
   fprintf(stderr, "%s(%d): ", __FILE__, __LINE__) ; \
   fprintf(stderr, msg, arg) ; \
   fprintf(stderr, "\n") ; \
   exit(1) ; \
}

#define ERRperror(msg)  { \
   perror(msg) ; \
   exit(1) ; \
}

struct doit_args {
	int			thrd_num;
	pthread_barrier_t	*barrier;
};

extern void *doit(void *);   /* thread */
extern void populate(double **wspace, int nelem, int nthreads) ;
extern unsigned int mod(int a, int b) ;

extern FILE *flog;

#define pr_info(fmt, ...)				\
	do {						\
		printf(fmt, ##__VA_ARGS__);		\
		fprintf(flog, fmt, ##__VA_ARGS__);	\
	} while (0)

extern double **wspace;
extern double *thrdres;
extern unsigned int nelem;
extern unsigned int niter;
